module Config.Format.Response exposing (..)

import Config.Style.Colour exposing (colourTheme)
import Element as E exposing (..)
import Element.Background as B


topLevelContainer : Element msg -> Element msg
topLevelContainer =
    el
        [ width fill
        , height fill
        , centerX
        , B.color colourTheme.backgroundLightGrey
        , height fill
        , scrollbarY
        ]


pageListDesktop : List (Attribute msg)
pageListDesktop =
    [ spacing 30
    , centerX
    , alignTop
    , height fill
    , paddingEach { top = 30, bottom = 30, left = 30, right = 30 }
    , width (fill |> minimum 100)
    , width (fill |> maximum 875)
    , scrollbarY
    ]
