module Config.Pages.Debate.Arguments.Inferences.ScratcherPioneers exposing (..)

import Config.Pages.Debate.Arguments.Types exposing (..)


argumentScratcherPioneers : Argument
argumentScratcherPioneers =
    { argumentTitle = "Tattoo Pioneers were Scratchers"
    , propositionTitle = "The original trailblazers of modern tattooing were scratchers."
    , propositionReductio = "Some tattoo artists condemn scratchers and their associated culture due to poor observation of sanitation standards and lack of mentorship and also simultaneously hold the original trailblazers of the tattoo industry in high esteem."
    , propositionSummary = "If what qualifies a given tattoo artist as a scratcher is poor observation of sanitation standards and lack of mentorship, then it's just straightforwardly entailed that the original trailblazers of the tattoo industry were scratchers."
    , proofLink = "https://www.umsu.de/trees/#(~6x(Px~4Qx~2Rx~2Sx)),(Qt),(Rt),(St)%7C=(Pt)"
    , argumentCertainty = 10
    , argumentImage = "tattooscratchers"
    , definitionTable =
        [ { definiendum = "P(x)"
          , definiens = "(x) is a scratcher"
          }
        , { definiendum = "Q(x)"
          , definiens = "(x) tattoos without a license"
          }
        , { definiendum = "R(x)"
          , definiens = "(x) tattoos without observing basic health standards"
          }
        , { definiendum = "S(x)"
          , definiens = "(x) tattoos without having undertaken apprenticeship"
          }
        , { definiendum = "x"
          , definiens = "a tattoo artist"
          }
        , { definiendum = "t"
          , definiens = "original trailblazers of modern tattooing"
          }
        ]
    , argumentFormalization =
        [ { premises =
                [ { premise = "A tattoo artist is a scratcher if, and only if, the tattoo artist tattoos without a license and/or one tattoos without observing basic health standards and/or one tattoos without having undertaken apprenticeship."
                  , notation = "∀x(Px↔Qx∨Rx∨Sx)"
                  }
                , { premise = "The original trailblazers of modern tattooing tattooed without licenses."
                  , notation = "Qt"
                  }
                , { premise = "The original trailblazers of modern tattooing tattooed without observing basic health standards."
                  , notation = "Rt"
                  }
                , { premise = "The original trailblazers of modern tattooing tattooed without having undertaken apprenticeship."
                  , notation = "St"
                  }
                ]
          , conclusion = "Therefore, the original trailblazers of modern tattooing were scratchers."
          , conclusionNotation = "Pt"
          }
        ]
    }
