module Config.Pages.Debate.Cuckery.CuckList.NinaTeicholz exposing (..)

import Config.Pages.Debate.Cuckery.Types exposing (..)
import Config.Helpers.Converters exposing (formatName)


cuckNinaTeicholz : Cuck
cuckNinaTeicholz =
    let
        name : String
        name =
            "Nina Teicholz"
    in
    { cuckImage = formatName name
    , cuckName = name
    , cuckSocial = "https://x.com/bigfatsurprise"
    , cuckDodges =
        [ { dodgeLink = "https://x.com/TheNutrivore/status/1556510529014882305?s=20"
          , dodgeDescription = NoReply
          , dodgeProposition = "The science linking red meat to heart disease is very weak."
          , dodgeReceipts = []
          , dodgeFallacy = Just (SpecificFallacy "")
          , dodgeNicksDoxasticState = Just Disbelief
          , dodgeNicksDoxasticReason = SpecificPropReason "The aggregate of the data suggests red meat increases the risk of heart disease."
          }
        , { dodgeLink = "https://x.com/TheNutrivore/status/1467571763865210881?s=20"
          , dodgeDescription = NoReply
          , dodgeProposition = "The available evidence supports limiting saturated fat intake for coronary heart disease risk reduction."
          , dodgeReceipts = []
          , dodgeFallacy = Just (SpecificFallacy "")
          , dodgeNicksDoxasticState = Just Belief
          , dodgeNicksDoxasticReason = SpecificPropReason commonPropReasons.propSaturatedFatReason
          }
        , { dodgeLink = "https://x.com/TheNutrivore/status/1538895943050878977?s=20"
          , dodgeDescription = NoReply
          , dodgeProposition = "Vegans pretend biology isn't real."
          , dodgeReceipts = []
          , dodgeFallacy = Just (SpecificFallacy "")
          , dodgeNicksDoxasticState = Just Agnostic
          , dodgeNicksDoxasticReason = VagueProp
          }
        ]
    }
