module Config.Pages.Debate.Cuckery.Helpers exposing (..)

import Config.Format.CardFormat exposing (..)
import Config.Format.Format
    exposing
        ( paragraphFontSize
        , paragraphSpacing
        )
import Config.Helpers.Converters exposing (formatSocial)
import Config.Style.Colour exposing (colourTheme)
import Config.Style.Transitions
    exposing
        ( hoverFontDarkOrange
        , transitionStyleFast
        , transitionStyleSlow
        )
import Config.Pages.Debate.Cuckery.CuckList.AdamSinger exposing (cuckAdamSinger)
import Config.Pages.Debate.Cuckery.CuckList.AmberOHearn exposing (cuckAmberOHearn)
import Config.Pages.Debate.Cuckery.CuckList.AnnChilders exposing (cuckAnnChilders)
import Config.Pages.Debate.Cuckery.CuckList.AnthonyGustin exposing (cuckAnthonyGustin)
import Config.Pages.Debate.Cuckery.CuckList.AshwaniGarg exposing (cuckAshwaniGarg)
import Config.Pages.Debate.Cuckery.CuckList.AustinHerbert exposing (cuckAustinHerbert)
import Config.Pages.Debate.Cuckery.CuckList.BartKay exposing (cuckBartKay)
import Config.Pages.Debate.Cuckery.CuckList.BenBikman exposing (cuckBenBikman)
import Config.Pages.Debate.Cuckery.CuckList.BennyMalone exposing (cuckBennyMalone)
import Config.Pages.Debate.Cuckery.CuckList.BradCampbell exposing (cuckBradCampbell)
import Config.Pages.Debate.Cuckery.CuckList.BradCohn exposing (cuckBradCohn)
import Config.Pages.Debate.Cuckery.CuckList.BradMarshall exposing (cuckBradMarshall)
import Config.Pages.Debate.Cuckery.CuckList.BretWeinstein exposing (cuckBretWeinstein)
import Config.Pages.Debate.Cuckery.CuckList.BrianKerley exposing (cuckBrianKerley)
import Config.Pages.Debate.Cuckery.CuckList.CarnivoreAurelius exposing (cuckCarnivoreAurelius)
import Config.Pages.Debate.Cuckery.CuckList.CateShanahan exposing (cuckCateShanahan)
import Config.Pages.Debate.Cuckery.CuckList.ChrisBoettcher exposing (cuckChrisBoettcher)
import Config.Pages.Debate.Cuckery.CuckList.ClaraAboel exposing (cuckClaraAboel)
import Config.Pages.Debate.Cuckery.CuckList.CliffHarvey exposing (cuckCliffHarvey)
import Config.Pages.Debate.Cuckery.CuckList.DaveFeldman exposing (cuckDaveFeldman)
import Config.Pages.Debate.Cuckery.CuckList.DavidDiamond exposing (cuckDavidDiamond)
import Config.Pages.Debate.Cuckery.CuckList.DavidGornoski exposing (cuckDavidGornoski)
import Config.Pages.Debate.Cuckery.CuckList.DianaRodgers exposing (cuckDianaRodgers)
import Config.Pages.Debate.Cuckery.CuckList.EdwardGoeke exposing (cuckEdwardGoeke)
import Config.Pages.Debate.Cuckery.CuckList.ElieJarrouge exposing (cuckElieJarrouge)
import Config.Pages.Debate.Cuckery.CuckList.GaryBrecka exposing (cuckGaryBrecka)
import Config.Pages.Debate.Cuckery.CuckList.GaryFettke exposing (cuckGaryFettke)
import Config.Pages.Debate.Cuckery.CuckList.GaryTaubes exposing (cuckGaryTaubes)
import Config.Pages.Debate.Cuckery.CuckList.GeorgeMartin exposing (cuckGeorgeMartin)
import Config.Pages.Debate.Cuckery.CuckList.GuyAustin exposing (cuckGuyAustin)
import Config.Pages.Debate.Cuckery.CuckList.IvorCummins exposing (cuckIvorCummins)
import Config.Pages.Debate.Cuckery.CuckList.JakeMey exposing (cuckJakeMey)
import Config.Pages.Debate.Cuckery.CuckList.JamesDiNicolantonio exposing (cuckJamesDiNicolantonio)
import Config.Pages.Debate.Cuckery.CuckList.JosephEverett exposing (cuckJosephEverett)
import Config.Pages.Debate.Cuckery.CuckList.JustinMares exposing (cuckJustinMares)
import Config.Pages.Debate.Cuckery.CuckList.KaitMalthaner exposing (cuckKaitMalthaner)
import Config.Pages.Debate.Cuckery.CuckList.KemMinnick exposing (cuckKemMinnick)
import Config.Pages.Debate.Cuckery.CuckList.KenBerry exposing (cuckKenBerry)
import Config.Pages.Debate.Cuckery.CuckList.KevinStock exposing (cuckKevinStock)
import Config.Pages.Debate.Cuckery.CuckList.KyleMamounis exposing (cuckKyleMamounis)
import Config.Pages.Debate.Cuckery.CuckList.MarkSisson exposing (cuckMarkSisson)
import Config.Pages.Debate.Cuckery.CuckList.MartyKendall exposing (cuckMartyKendall)
import Config.Pages.Debate.Cuckery.CuckList.MaxLugavere exposing (cuckMaxLugavere)
import Config.Pages.Debate.Cuckery.CuckList.MichaelKummer exposing (cuckMichaelKummer)
import Config.Pages.Debate.Cuckery.CuckList.MichaelManderville exposing (cuckMichaelManderville)
import Config.Pages.Debate.Cuckery.CuckList.MikeMutzel exposing (cuckMikeMutzel)
import Config.Pages.Debate.Cuckery.CuckList.MikeSweeney exposing (cuckMikeSweeney)
import Config.Pages.Debate.Cuckery.CuckList.NickEggleton exposing (cuckNickEggleton)
import Config.Pages.Debate.Cuckery.CuckList.NinaTeicholz exposing (cuckNinaTeicholz)
import Config.Pages.Debate.Cuckery.CuckList.NorstrongChris exposing (cuckNorstrongChris)
import Config.Pages.Debate.Cuckery.CuckList.PaulMason exposing (cuckPaulMason)
import Config.Pages.Debate.Cuckery.CuckList.PaulSaladino exposing (cuckPaulSaladino)
import Config.Pages.Debate.Cuckery.CuckList.PhilipOvadia exposing (cuckPhilipOvadia)
import Config.Pages.Debate.Cuckery.CuckList.PhilippeStephenson exposing (cuckPhilippeStephenson)
import Config.Pages.Debate.Cuckery.CuckList.RalphNapolitano exposing (cuckRalphNapolitano)
import Config.Pages.Debate.Cuckery.CuckList.RaphaelSirtoli exposing (cuckRaphaelSirtoli)
import Config.Pages.Debate.Cuckery.CuckList.RobMeijer exposing (cuckRobMeijer)
import Config.Pages.Debate.Cuckery.CuckList.RobbWolf exposing (cuckRobbWolf)
import Config.Pages.Debate.Cuckery.CuckList.SebastianRamirez exposing (cuckSebastianRamirez)
import Config.Pages.Debate.Cuckery.CuckList.SimonGoddek exposing (cuckSimonGoddek)
import Config.Pages.Debate.Cuckery.CuckList.TravisStatham exposing (cuckTravisStatham)
import Config.Pages.Debate.Cuckery.CuckList.TristanHaggard exposing (cuckTristanHaggard)
import Config.Pages.Debate.Cuckery.CuckList.TroKalayjian exposing (cuckTroKalayjian)
import Config.Pages.Debate.Cuckery.CuckList.TuckerGoodrich exposing (cuckTuckerGoodrich)
import Config.Pages.Debate.Cuckery.CuckList.ZoeHarcombe exposing (cuckZoeHarcombe)
import Config.Pages.Debate.Cuckery.CuckList.ZsofiaClemens exposing (cuckZsofiaClemens)
import Config.Pages.Debate.Cuckery.Types exposing (..)
import Element as E exposing (..)
import Element.Background as B
import Element.Border as D
import Element.Font as F
import Html.Attributes as H


desktopCuckMaker : Cuck -> Element msg
desktopCuckMaker cuck =
    row
        topLevelBox
        [ cardImageMaker (cuckImage cuck) (cuckSocial cuck)
        , cardMaker
            [ cardTitleMaker (cuckTitle cuck)
            , cardFormatter
                [ cardContentSpacing
                    [ column
                        fieldSpacer
                        [ socialMaker cuck
                        , dodgeTitle cuck
                        , dodgeMaker cuck
                        ]
                    ]
                ]
            ]
        ]


mobileCuckMaker : Cuck -> Element msg
mobileCuckMaker cuck =
    column
        topLevelBox
        [ column [] []
        , cardMaker
            [ cardTitleMaker (cuckTitle cuck)
            , cardFormatter
                [ cardContentSpacing
                    [ column
                        fieldSpacer
                        [ column
                            [ alignTop
                            , centerX
                            , alignLeft
                            , spacing 3
                            ]
                            [ row [ spacing 10 ]
                                [ cardImageMakerMobile (cuckImage cuck) (cuckSocial cuck)
                                , socialMaker cuck
                                ]
                            , dodgeTitle cuck
                            , dodgeMaker cuck
                            ]
                        ]
                    ]
                ]
            ]
        ]


cuckImage :
    Cuck
    ->
        { src : String
        , description : String
        }
cuckImage cuck =
    { src = "cucks/" ++ cuck.cuckImage ++ "/" ++ cuck.cuckImage ++ ".png"
    , description = cuck.cuckName
    }


cuckTitle : Cuck -> String
cuckTitle cuck =
    cuck.cuckName


cuckSocial : Cuck -> String
cuckSocial cuck =
    cuck.cuckSocial


dodgeMaker : Cuck -> Element msg
dodgeMaker cuck =
    column
        [ spacing 10
        , width fill
        ]
    <|
        List.map2 (\x y -> makeDodge x y)
            cuck.cuckDodges
            (List.range 1 (List.length cuck.cuckDodges))


socialMaker : Cuck -> Element msg
socialMaker cuck =
    paragraph
        ([ F.color colourTheme.textLightGrey
         , paragraphSpacing
         , paragraphFontSize
         , F.bold
         ]
            ++ [ F.size 18
               , spacing 8
               ]
        )
        [ text "Social: "
        , newTabLink
            [ paragraphFontSize
            , F.color colourTheme.textLightOrange
            ]
            { url = cuck.cuckSocial
            , label =
                el
                    [ transitionStyleSlow
                    , hoverFontDarkOrange
                    ]
                <|
                    text (formatSocial cuck.cuckSocial)
            }
        ]


dodgeTitle : Cuck -> Element msg
dodgeTitle cuck =
    paragraph
        ([ F.color colourTheme.textLightGrey
         , paragraphSpacing
         , paragraphFontSize
         , F.bold
         ]
            ++ [ F.size 18
               ]
        )
        [ text "Dodges: " ]


makeDodge : Dodge -> Int -> Element msg
makeDodge dodgeEntry index =
    column
        ([ F.color colourTheme.textLightGrey
         , paragraphSpacing
         , paragraphFontSize
         , F.bold
         , alignLeft
         ]
            ++ [ spacing 8
               , width fill
               ]
        )
        [ row
            [ width fill
            , paddingEach
                { top = 0
                , right = 0
                , bottom = 0
                , left = 35
                }
            ]
            [ column
                ([ F.color colourTheme.textLightGrey
                 , paragraphSpacing
                 , paragraphFontSize
                 ]
                    ++ [ F.size 18
                       , alignTop
                       , alignRight
                       , F.alignRight
                       ]
                )
                [ text (String.fromInt index ++ ". ") ]
            , column
                [ spacing 3
                , width fill
                ]
                [ circumstanceMaker dodgeEntry
                , column
                    [ spacing 3
                    , width fill
                    ]
                    [ propositionMaker dodgeEntry
                    , reductioMaker dodgeEntry
                    , attitudeMaker dodgeEntry
                    , reasonMaker dodgeEntry
                    ]
                ]
            ]
        ]


dodgeWidth =
    width <| px 93


formatProposition : String -> String
formatProposition proposition =
    if proposition == "N/A" then
        proposition

    else
        "\"" ++ proposition ++ "\""


dodgeCounter : Int -> Element msg
dodgeCounter index =
    column
        ([ F.color colourTheme.textLightGrey
         , paragraphSpacing
         , paragraphFontSize
         ]
            ++ [ F.size 18
               ]
        )
        [ text (String.fromInt index ++ ". ") ]


circumstanceMaker : Dodge -> Element msg
circumstanceMaker dodgeEntry =
    column
        [ width fill
        ]
        [ newTabLink
            [ paragraphFontSize
            , F.color colourTheme.textLightOrange
            ]
            { url = dodgeEntry.dodgeLink
            , label =
                row [ F.size 18 ]
                    [ column [ width fill ]
                        [ paragraph []
                            [ el
                                [ transitionStyleSlow
                                , hoverFontDarkOrange
                                ]
                              <|
                                text
                                    (case dodgeEntry.dodgeDescription of
                                        NoReply ->
                                            "Debate invitation extended with no response"

                                        RanAway ->
                                            "Engaged in written debate and ran away when cornered"

                                        GhostedMe ->
                                            "Debate invitation accepted with no follow-up"

                                        OutrightNo ->
                                            "Debate invitation declined"

                                        InTooDeep ->
                                            "Debate invitation accepted and subsequently retracted"

                                        KillScreen ->
                                            "All further debate invitations preemptively declined"

                                        VagueGesture ->
                                            "Chose to gesture vaguely instead of engaging"
                                    )
                            , paragraph [ F.color colourTheme.textLightGrey ] [ text "." ]
                            , column
                                [ spacing 5
                                , F.size 12
                                ]
                                (List.indexedMap
                                    (\index2 link ->
                                        newTabLink
                                            [ paddingEach
                                                { top = 0
                                                , right = 0
                                                , bottom = 0
                                                , left = 5
                                                }
                                            ]
                                            { url = link
                                            , label =
                                                row [ moveUp 5 ]
                                                    [ el
                                                        [ transitionStyleSlow
                                                        , hoverFontDarkOrange
                                                        ]
                                                      <|
                                                        text (String.fromInt (index2 + 1))
                                                    , text ", " |> el [ F.color colourTheme.textLightGrey ]
                                                    ]
                                            }
                                    )
                                    dodgeEntry.dodgeReceipts
                                )
                            ]
                        ]
                    ]
            }
        ]


propositionMaker : Dodge -> Element msg
propositionMaker dodgeEntry =
    row
        [ F.color colourTheme.textLightGrey
        , paragraphSpacing
        , paragraphFontSize
        , F.bold
        ]
        [ paragraph
            [ alignTop
            , dodgeWidth
            ]
            [ text "Proposition:"
            ]
        , paragraph
            [ E.width fill
            , alignLeft
            ]
            [ paragraph [ F.regular ] [ text (formatProposition dodgeEntry.dodgeProposition) ]
            ]
        ]


attitudeMaker : Dodge -> Element msg
attitudeMaker dodgeEntry =
    row
        ([ F.color colourTheme.textLightGrey
         , paragraphSpacing
         , paragraphFontSize
         , F.bold
         ]
            ++ [ width fill ]
        )
        [ paragraph
            [ alignTop
            , dodgeWidth
            ]
            [ text "Attitude:"
            ]
        , paragraph
            [ E.width fill
            , alignLeft
            ]
            [ case dodgeEntry.dodgeNicksDoxasticState of
                Nothing ->
                    paragraph [ F.regular ] [ text "I don't form a doxastic state." ]

                Just Belief ->
                    paragraph [ F.regular ]
                        [ text "I lean more toward "
                        , el [ F.bold ] (text "TRUE")
                        , text " than false."
                        ]

                Just Disbelief ->
                    paragraph [ F.regular ]
                        [ text "I lean more toward "
                        , text "FALSE" |> el [ F.bold ]
                        , text " than true."
                        ]

                Just Agnostic ->
                    el [ F.regular ] (text "I don't form beliefs about this proposition.")
            ]
        ]


reductioMaker : Dodge -> Element msg
reductioMaker dodgeEntry =
    case dodgeEntry.dodgeFallacy of
        Nothing ->
            none

        Just fallacy ->
            case fallacy of
                SpecificFallacy str ->
                    if String.isEmpty str then
                        none

                    else
                        displayFallacy str

                AppealToNature ->
                    displayFallacy "Appeal to Nature"

                AppealToTradition ->
                    displayFallacy "Appeal to Tradition"

                AppealToIgnorance ->
                    displayFallacy "Appeal to Ignorance"

                AppealFromIncredulity ->
                    displayFallacy "Appeal from Incredulity"

                RedHerring ->
                    displayFallacy "Red Herring"

                BeggingTheQuestion ->
                    displayFallacy "Begging the Question"

                Strawman ->
                    displayFallacy "Strawman"

                Equivocation ->
                    displayFallacy "Equivocation"

                GeneticFallacy ->
                    displayFallacy "Genetic Fallacy"

                MotteAndBailey ->
                    displayFallacy "Motte and Bailey"


reasonMaker : Dodge -> Element msg
reasonMaker dodgeEntry =
    row
        ([ F.color colourTheme.textLightGrey
         , paragraphSpacing
         , paragraphFontSize
         , F.bold
         ]
            ++ [ width fill ]
        )
        [ paragraph
            [ alignTop
            , dodgeWidth
            ]
            [ text "Reason:"
            ]
        , paragraph [ F.regular ]
            [ text <|
                case dodgeEntry.dodgeNicksDoxasticReason of
                    NoProp ->
                        "There is no proposition to evaluate."

                    VagueProp ->
                        "The proposition is too vague to evaluate."

                    SpecificPropReason str ->
                        str
            ]
        ]


displayFallacy : String -> Element msg
displayFallacy fallacyText =
    row
        [ F.color colourTheme.textLightGrey
        , paragraphSpacing
        , paragraphFontSize
        , F.bold
        ]
        [ paragraph
            [ alignTop
            , dodgeWidth
            ]
            [ text "Fallacy:"
            ]
        , paragraph
            [ E.width fill
            , alignLeft
            ]
            [ paragraph [ F.regular ]
                [ text fallacyText ]
            ]
        ]


cuckList =
    [ cuckAdamSinger
    , cuckAmberOHearn
    , cuckAnnChilders
    , cuckAnthonyGustin
    , cuckAshwaniGarg
    , cuckAustinHerbert
    , cuckBartKay
    , cuckBenBikman
    , cuckBennyMalone
    , cuckBradCampbell
    , cuckBradCohn
    , cuckBradMarshall
    , cuckBretWeinstein
    , cuckBrianKerley
    , cuckCarnivoreAurelius
    , cuckCateShanahan
    , cuckChrisBoettcher
    , cuckClaraAboel
    , cuckCliffHarvey
    , cuckDaveFeldman
    , cuckDavidDiamond
    , cuckDavidGornoski
    , cuckDianaRodgers
    , cuckEdwardGoeke
    , cuckElieJarrouge
    , cuckGaryBrecka
    , cuckGaryFettke
    , cuckGaryTaubes
    , cuckGeorgeMartin
    , cuckGuyAustin
    , cuckIvorCummins
    , cuckJakeMey
    , cuckJamesDiNicolantonio
    , cuckJosephEverett
    , cuckJustinMares
    , cuckKaitMalthaner
    , cuckKemMinnick
    , cuckKenBerry
    , cuckKevinStock
    , cuckKyleMamounis
    , cuckMarkSisson
    , cuckMartyKendall
    , cuckMaxLugavere
    , cuckMichaelKummer
    , cuckMichaelManderville
    , cuckMikeMutzel
    , cuckMikeSweeney
    , cuckNickEggleton
    , cuckNinaTeicholz
    , cuckNorstrongChris
    , cuckPaulMason
    , cuckPaulSaladino
    , cuckPhilipOvadia
    , cuckPhilippeStephenson
    , cuckRalphNapolitano
    , cuckRaphaelSirtoli
    , cuckRobbWolf
    , cuckRobMeijer
    , cuckSebastianRamirez
    , cuckSimonGoddek
    , cuckTravisStatham
    , cuckTristanHaggard
    , cuckTroKalayjian
    , cuckTuckerGoodrich
    , cuckZoeHarcombe
    , cuckZsofiaClemens
    ]


cuckListNumber : Int
cuckListNumber =
    List.length cuckList
