module Config.Pages.Debate.Debate.Pages.Arguments exposing (..)

import Config.Data.Identity
    exposing
        ( pageNames
        , url
        )
import Config.Helpers.Converters exposing (formatName)
import Config.Pages.Debate.Arguments.Helpers exposing (argumentListNumber)
import Config.Pages.Debate.Debate.Types exposing (..)


debateArguments : Debate
debateArguments =
    let
        name =
            "Arguments"
    in
    { debateTitle = name
    , debateLink = formatName (url ++ pageNames.pageArguments)
    , debateCount = argumentListNumber
    , debateImage = formatName name
    , debateDescription = "This page features arguments that I hold to be sound. I'm open to hearing all challenges, as I am ready to engage with and defend any argument listed."
    }
