module Config.Pages.Debate.Gibberish.Domains.Metaphysics exposing (..)

import Config.Helpers.Converters exposing (formatName)
import Config.Pages.Debate.Gibberish.Types exposing (..)


metaphysicsGibberish : Gibberish
metaphysicsGibberish =
    let
        name =
            "Metaphysics"
    in
    { gibberishTitle = name
    , gibberishImage = formatName name
    , gibberishLink = "https://en.wikipedia.org/wiki/Metaphysics"
    , gibberishDescription = "Metaphysics is a branch of philosophy that explores the fundamental nature of reality, including concepts such as existence, being, causality, and the nature of objects and their properties. It seeks to answer profound questions about what exists and the structure of the world beyond empirical observation. Traditionally, metaphysics includes subfields like ontology, which specifically studies the nature of being."
    , gibberishTerms =
        [ { term = "Correspondence Theory of Truth"
          , strength = 10
          , explanation = SpecificExplanation "While I do take there to be a world outside my perception, and I do believe that the correspondence between my perceptions and the world outside of my perceptions would be a good way to infer the relative truth value of a proposition, this doesn't seem a definition of truth that is in any way actionable. This, to me, makes the correspondence theory of truth to be practically useless."
          }
        , { term = "Metaphysical Essence"
          , strength = 5
          , explanation = NoClue
          }
        , { term = "Metaphysical Modality"
          , strength = 0
          , explanation = SpecificExplanation "Any attempt at unpacking this that I've heard has more or less cashed out into a logical modality, but it seems to be taken as distinct from logical modality. As a non-logical modality, I have no idea what it's supposed to be."
          }
        , { term = "Non-Physical Mental Entities"
          , strength = 5
          , explanation = NoClue
          }
        , { term = "Ontological Modality"
          , strength = 0
          , explanation = SpecificExplanation "Any attempt at unpacking this that I've heard has more or less cashed out into a logical modality, but it seems to be taken as distinct from logical modality. As a non-logical modality, I have no idea what it's supposed to be."
          }
        , { term = "Subjective Idealism"
          , strength = 5
          , explanation = NoClue
          }
        , { term = "Ultimate Grounding"
          , strength = 2
          , explanation = SpecificExplanation "It's completely unclear what this theo-babble is meant to communicate. I assume it has something to do with the absence of antecedent conditions and/or irreducibility that provide some sort of \"best epistemology\" or something, but I can't be sure. It just sounds like gobbledy"
          }
        ]
    }
