module Config.Pages.Debate.Gibberish.Domains.PhilOfLanguage exposing (..)

import Config.Helpers.Converters exposing (formatName)
import Config.Pages.Debate.Gibberish.Types exposing (..)


philOfLanguageGibberish : Gibberish
philOfLanguageGibberish =
    let
        name =
            "Philosophy of Language"
    in
    { gibberishTitle = name
    , gibberishImage = formatName name
    , gibberishLink = "https://en.wikipedia.org/wiki/Philosophy_of_language"
    , gibberishDescription = "The philosophy of language is a branch of philosophy that investigates the nature, origins, and usage of language, focusing on how language relates to meaning, thought, and reality. It explores fundamental questions about the nature of words and sentences, how they convey complex meanings, and the relationship between language users and the world. Key topics include meaning, reference, intentionality, and the structure of language itself."
    , gibberishTerms =
        [ { term = "Direct Reference"
          , strength = 2
          , explanation = SpecificExplanation "I don't understand the term usage as it's been used and unpacked in conversation. I don't understand what it means for a word to \"point to\" an object, and I also don't understand what semantic advantage or distinction this has to a mundane, ostensibly non-direct reference to an object in speech."
          }
        , { term = "Semantic Primitive"
          , strength = 2
          , explanation = SpecificExplanation "I typically don't really understand irreducibility language like \"primitive\" in philosophy. Most philosophers seem to just use it as a sort of profound-sounding placeholder for when their personal creativity for explanation runs dry. No idea what it's meant to mean here, though."
          }
        ]
    }
