module Config.Pages.Debate.Gibberish.Domains.Theology exposing (..)

import Config.Helpers.Converters exposing (formatName)
import Config.Pages.Debate.Gibberish.Types exposing (..)


theologyGibberish : Gibberish
theologyGibberish =
    let
        name =
            "Theology"
    in
    { gibberishTitle = name
    , gibberishImage = formatName name
    , gibberishLink = "https://en.wikipedia.org/wiki/Theology"
    , gibberishDescription = "Theology is the study of religious beliefs and practices, focusing on the nature of divinity and the relationship between the divine and humanity. It encompasses various disciplines, including systematic theology, biblical theology, and practical theology, each exploring different aspects of faith and spirituality. Essentially, theology seeks to provide a coherent understanding of God and religious experience, guiding adherents in their beliefs and practices."
    , gibberishTerms =
        [ { term = "Divine Simplicity"
          , strength = 3
          , explanation = SpecificExplanation "This seems to be an assertion that God is somehow not made up of multiple parts. Allegedly, God is just a single part. This is sometimes used to avoid hilarious reductios applied to the fine-tuning argument for God, by claiming that God does not have a constitution that can be finely tuned. However, I don't see why constitution must entail multiple parts anyway. Additionally, even if we grant it, it's just an empirical claim that hasn't been substantiated."
          }
        , { term = "Equal Ultimacy"
          , strength = 5
          , explanation = NoClue
          }
        , { term = "Theism"
          , strength = 4
          , explanation = SpecificExplanation "I understand some God concepts, but most God concepts just sound like gibberish to me. For instance, most God concepts I've come across seem to suggest that God exists, but God exists outside the confines of what is (like physical reality) and simultaneously inhabits all space inside of what is. I have no idea how to interpret mumbo jumbo like that."
          }
        , { term = "Transcendental Oneness"
          , strength = 0
          , explanation = SpecificExplanation "Just sounds like presuppositionalist theobabble. I don't think it means anything."
          }
        , { term = "Transcendental Realism"
          , strength = 5
          , explanation = NoClue
          }
        ]
    }
