module Config.Pages.Interviews.Episodes.SigmaNutritionRadio exposing (..)

import Config.Pages.Interviews.Types exposing (..)
import Config.Helpers.Converters exposing (formatName)

sigmaNutritionRadio : Interview
sigmaNutritionRadio =
    let
        name : String
        name =
            "Sigma Nutrition Radio"
    in
    { interviewName = name
    , interviewImage = formatName name
    , interviewSocial = "https://x.com/NutritionDanny"
    , interviewAppearances =
        [ { appearanceTitle = "Micronutrients, Anti-nutrients, and Non-essential Nutrients"
          , appearanceEpisode = "360"
          , appearanceLink = "https://sigmanutrition.com/episode360/"
          , appearanceExperience = 10
          , appearanceYear = "November 12th, 2020"
          , appearanceSubjects =
                [ { subject = "How best to measure nutrient density." }
                , { subject = "The downsides of maximizing nutrient density." }
                , { subject = "Anti-nutrients: how relevant are they?" }
                , { subject = "Understanding the effect of phytate, oxalate, etc." }
                , { subject = "Hard to get nutrients in typical diets." }
                , { subject = "Synergistic and moderating effects of nutrients." }
                , { subject = "Non-essential nutrients & importance for health." }
                ]
          }
        ]
    }
